﻿Imports System.IO
Imports System.Threading
Imports System.ComponentModel

Public Class Form1

    Private TESTOletto As New List(Of String)
    Private StWa As New Diagnostics.Stopwatch
    Private Quante As UInt32 = 1000000
    Private RigheVisualizzate As UInt16
    Private FinoA As UInt32
    Private Trovato As Boolean

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LabLEGGI.Text = "Scegli un file testo"
        LabGENERA.Text = "Puoi generare un file di esempio da un milione di righe"
        VScrollTESTO.BringToFront()
    End Sub

    Private Sub ButGENERA_Click(sender As Object, e As EventArgs) Handles ButGENERA.Click
        '**** CREA UN FILE TESTO DA UN MILIONE DI RIGHE ****
        Dim UnMilione(Quante - 1) As String
        Dim NomeFile As String = Application.StartupPath & "\UnMilioneDiRighe.txt"
        LabGENERA.Text = "Il file generato viene salvato in: " & NomeFile
        StWa.Reset() ' azzera il tempo
        AggiornaLOG(" Genero " & Quante.ToString("#.#") & " di righe")
        For i As UInt32 = 0 To Quante - 1
            UnMilione(i) = "Riga N." & (i + 1).ToString("0000000") & " - Testo di grandi dimensioni, per verifica velocità di caricamento e visualizzazione, creato in modo fittizio ed automatizzato."
        Next
        AggiornaLOG(" file testo con " & Quante.ToString("#,#") & " righe, generato")
        File.WriteAllLines(NomeFile, UnMilione) ' Salva matrice di stringhe
        AggiornaLOG(" file testo con " & Quante.ToString("#,#") & " righe, salvato")
    End Sub

    Private Sub ButLEGGI_Click(sender As Object, e As EventArgs) Handles ButLEGGI.Click
        ' ****  LEGGE E VISUALIZZA UN FILE TESTO  ****
        OpenFileDialog1.InitialDirectory = Application.StartupPath
        OpenFileDialog1.Filter = "File di testo (*.txt)|*.txt|Tutti i file (*.*)|*.*"
        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
            Dim PercorsoDelFile As String = OpenFileDialog1.FileName
            VScrollTESTO.Maximum = 1 ' valore di partenza, evita errori
            VScrollTESTO.Value = 1 ' valore di partenza, permette il cambio a zero
            StWa.Reset() ' azzera il tempo

            ' modifica in ver 1.1.0.0, caricamento asincrono
            ButGENERA.Enabled = False
            If BackgroundWorker1.IsBusy Then Exit Sub
            AggiornaLOG(" inizio caricamento file testo")
            BackgroundWorker1.RunWorkerAsync(PercorsoDelFile)
            Timer1.Enabled = True ' visualizza il tempo
            ' codice successivo al caricamento in:
            ' BackgroundWorker1_RunWorkerCompleted
        End If
    End Sub

    Private Sub VScrollTESTO_ValueChanged(sender As Object, e As EventArgs) Handles VScrollTESTO.ValueChanged
        ' **** SCORRE IL TESTO ****
        ' se TESTOletto ancora non è stato riempito oppure tutte le ultime righe sono visualizzate si esce 
        If TESTOletto.Count = 0 Or VScrollTESTO.Value + RigheVisualizzate > TESTOletto.Count Then Exit Sub
        ' aggiornamento valore massimo, serve se si è ridimensionata la TextTESTO
        VScrollTESTO.Maximum = (TESTOletto.Count - RigheVisualizzate) + 1
        ' visualizzazione delle sole righe necessarie a riempire la TextBox TextTESTO
        RichTextBox.Lines = TESTOletto.GetRange(VScrollTESTO.Value, RigheVisualizzate).ToArray
    End Sub

    Sub AggiornaLOG(Log As String)
        '**** VISUALIZZA TEMPI E INFO ****
        ListBoxLOG.Items.Add(Now & " +" & StWa.ElapsedMilliseconds & " ms. [" & Log & " ]")
        ListBoxLOG.SetSelected(ListBoxLOG.Items.Count - 1, True)
        StWa.Reset()
        StWa.Start()
        Application.DoEvents()
    End Sub

    Private Sub Form1_SizeChanged(sender As Object, e As EventArgs) Handles Me.SizeChanged
        ' **** RIDIMENSIONAMENTO ****
        RichTextBox.Width = Me.Width - 40
        RichTextBox.Height = Me.Height - 240
        ListBoxLOG.Width = Me.Width - 40
        ListBoxLOG.Top = Me.Height - 144
        VScrollTESTO.Left = Me.Width - 46
        VScrollTESTO.Height = RichTextBox.Height - 2
        ' calcolo delle righe visualizzabili in TextTESTO
        RigheVisualizzate = RichTextBox.Height \ 13
        ' prima di aggiornare, controllo che i parametri non vadano fuori range
        If TESTOletto.Count = 0 Or VScrollTESTO.Value + RigheVisualizzate > TESTOletto.Count Then Exit Sub
        ' aggiornamento in accordo con la nuova dimensione della TextTESTO
        RichTextBox.Lines = TESTOletto.GetRange(VScrollTESTO.Value, RigheVisualizzate).ToArray
        VScrollTESTO.Minimum = 0
    End Sub

    Private Sub TextSEL_KeyDown(sender As Object, e As KeyEventArgs) Handles TextSEL.KeyDown
        If e.KeyCode = Keys.Enter Or e.KeyCode = Keys.Return Then
            SelezionaRIGA()
        End If
    End Sub

    Private Sub ButMENO_Click(sender As Object, e As EventArgs) Handles ButMENO.Click
        Dim Numero As UInt32
        If UInt32.TryParse(TextSEL.Text, Numero) And TESTOletto.Count <> 0 Then
            Numero -= 1
            TextSEL.Text = Numero
            SelezionaRIGA()
        Else
            TextSEL.Text = 1
            SelezionaRIGA()
        End If
    End Sub

    Private Sub ButPIU_Click(sender As Object, e As EventArgs) Handles ButPIU.Click
        Dim Numero As UInt32
        If UInt32.TryParse(TextSEL.Text, Numero) And TESTOletto.Count <> 0 Then
            Numero += 1
            TextSEL.Text = Numero
            SelezionaRIGA()
        Else
            TextSEL.Text = TESTOletto.Count
            SelezionaRIGA()
        End If
    End Sub

    ' aggiunte versione 1.1.0.0

    Private Sub SelezionaRIGA()
        Dim Numero As UInt32
        Dim Pos As UInt16
        If UInt32.TryParse(TextSEL.Text, Numero) And TESTOletto.Count <> 0 Then
            If Numero > TESTOletto.Count Then Numero = TESTOletto.Count : TextSEL.Text = TESTOletto.Count
            If Numero = 0 Then Numero = 1 : TextSEL.Text = 1
            If Numero > RigheVisualizzate Then
                VScrollTESTO.Value = Numero - RigheVisualizzate
                For i = 0 To RigheVisualizzate - 2
                    Pos += TESTOletto(Numero - RigheVisualizzate + i).Length
                Next
                RichTextBox.[Select](Pos + 30, TESTOletto(Numero - 1).Length)
            Else
                If TESTOletto.Count < RigheVisualizzate Then
                    If Numero = 1 Then
                        RichTextBox.[Select](0, TESTOletto(0).Length + 1)
                    Else
                        For i As UInt16 = 0 To Numero - 2
                            Pos += TESTOletto(i).Length + 1
                        Next
                        RichTextBox.[Select](Pos, TESTOletto(Numero - 1).Length + 1)
                    End If
                Else
                    VScrollTESTO.Value = Numero - 1
                    RichTextBox.[Select](0, TESTOletto(Numero - 1).Length)
                End If
            End If
        End If
    End Sub

    Private Sub BackgroundWorker1_DoWork(sender As Object, e As DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        TESTOletto = File.ReadAllLines(e.Argument).ToList ' legge il file testo
        e.Result = "Lette n. " & (TESTOletto.Count).ToString("#,#") & " righe da: " & e.Argument
    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        Timer1.Enabled = False
        ButGENERA.Enabled = True
        LabLEGGI.Text = e.Result
        AggiornaLOG(" file testo con " & (TESTOletto.Count).ToString("#,#") & " righe, caricato")
        If RigheVisualizzate > TESTOletto.Count Then
            ' il testo è più corto della finestra, lo visualizzo tutto
            VScrollTESTO.Maximum = TESTOletto.Count
            RichTextBox.Lines = TESTOletto.ToArray
        Else
            ' il testo è più lungo della finestra, imposto la scrollbar
            VScrollTESTO.Maximum = (TESTOletto.Count - RigheVisualizzate) + 1
        End If
        VScrollTESTO.Value = 0 ' cambio il valore per richiamare l'evento VScrollTESTO_ValueChanged
        AggiornaLOG(" file testo con " & (TESTOletto.Count).ToString("#,#") & " righe, visualizzato")
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        LabLEGGI.Text = "Lettura da file in corso " & StWa.ElapsedMilliseconds & " ms. "
    End Sub
End Class
